// (C) Copyright 2002-2007 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//
// Cyrille Fauvel
// Autodesk Developer Network

//-----------------------------------------------------------------------------
//----- acrxEntryPoint.cpp
//-----------------------------------------------------------------------------
#include "StdAfx.h"
#include "resource.h"

#include "../OPLine/asdkOPLineStyle.h"
#include "../OPLine/asdkOPLine.h"

//-----------------------------------------------------------------------------
#define szRDS _RXST("asdk")

//-----------------------------------------------------------------------------
//----- ObjectARX EntryPoint
class COPLineCmdApp : public AcRxArxApp {

public:
	COPLineCmdApp () : AcRxArxApp () {}

	virtual AcRx::AppRetCode On_kInitAppMsg (void *pkt) {
		// TODO: Load dependencies here
		if ( !acrxLoadModule (_T("asdkOPLine.dbx"), 0) )
			return (AcRx::kRetError) ;

		// You *must* call On_kInitAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kInitAppMsg (pkt) ;
		
		// TODO: Add your initialization code here

		return (retCode) ;
	}

	virtual AcRx::AppRetCode On_kUnloadAppMsg (void *pkt) {
		// TODO: Add your code here

		// You *must* call On_kUnloadAppMsg here
		AcRx::AppRetCode retCode =AcRxArxApp::On_kUnloadAppMsg (pkt) ;

		// TODO: Unload dependencies here
		acrxUnloadModule (_T("asdkOPLine.dbx")) ;

		return (retCode) ;
	}

	virtual void RegisterServerComponents () {
	}


	// - asdkOPLineCmd._OPL command (do not rename)
	static void asdkOPLineCmd_OPL(void)
	{
		ads_name en ;
		ads_point pt ;
		if ( acedEntSel (NULL, en, pt) != RTNORM )
			return ;

		AcDbObjectId id ;
		acdbGetObjectId (id, en) ;

		AcDbObjectPointer<asdkOPLine> p ;
		p.create () ;
		p->makeFrom (id) ;
		
		AcDbDictionaryPointer pNOD (curDoc ()->database ()->namedObjectsDictionaryId (), AcDb::kForRead) ;
		if ( pNOD->getAt (ASDK_OPLINESTYLE, id) == Acad::eKeyNotFound ) {
			//- We need to close the NOD before, otherwise we will get an error
			pNOD.close () ;
			COPLineCmdApp::asdkOPLineCmd_OPLS () ;
			//- and reopen it now
			pNOD.open (curDoc ()->database ()->namedObjectsDictionaryId (), AcDb::kForRead) ;
			pNOD->getAt (ASDK_OPLINESTYLE, id) ;
		}
		AcDbDictionaryPointer pDct (id, AcDb::kForRead) ;
		pDct->getAt (ASDK_OPLINESTYLE_STD, id) ;
		p->setOPLineStyle (id) ;
	}

	// - asdkOPLineCmd._OPLS command (do not rename)
	static void asdkOPLineCmd_OPLS(void)
	{
		AcDbObjectId ids ;
		AcDbSymbolUtilities::getLinetypeId (ids, _T("BYLAYER"), curDoc ()->database ()) ;

		AcDbObjectPointer<asdkOPLineStyle> pStyle ;
		pStyle.create () ;
		pStyle->appendOffset (2, ids, 1, AcDb::kLnWtByLwDefault) ;
		pStyle->appendOffset (-2, ids, 3, AcDb::kLnWtByLwDefault) ;

		AcDbDictionaryPointer pNOD (curDoc ()->database ()->namedObjectsDictionaryId (), AcDb::kForWrite) ;
		AcDbDictionaryPointer pDct ;
		pDct.create () ;
		pNOD->setAt (ASDK_OPLINESTYLE, pDct, ids) ;
		pDct->setAt (ASDK_OPLINESTYLE_STD, pStyle, ids) ;
	}
} ;

//-----------------------------------------------------------------------------
IMPLEMENT_ARX_ENTRYPOINT(COPLineCmdApp)

ACED_ARXCOMMAND_ENTRY_AUTO(COPLineCmdApp, asdkOPLineCmd, _OPL, OPL, ACRX_CMD_TRANSPARENT, NULL)
ACED_ARXCOMMAND_ENTRY_AUTO(COPLineCmdApp, asdkOPLineCmd, _OPLS, OPLS, ACRX_CMD_TRANSPARENT, NULL)
